package ch.ipi.hello.web.form;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import com.google.common.collect.Maps;

public class Service {

  private static final Map<UUID, FormularData> REPO = Maps.newConcurrentMap();

  static {
    final List<UUID> rnd = Stream.generate(UUID::randomUUID).limit(10L).collect(Collectors.toList());
    rnd.stream().map(FormularData::new).forEachOrdered(Service::create);
  }

  public static Collection<UUID> findFormInstanceIds(final List<UUID> requiredIds) {
    return requiredIds.isEmpty() ? REPO.keySet()
        : requiredIds.stream().filter(REPO::containsKey).collect(Collectors.toList());
  }

  public static FormularData readOne(final UUID uuid) {
    return REPO.get(uuid);
  }

  public static FormularData create(final FormularData data) {
    REPO.put(data.getID(), data);
    return data;
  }

}
