ACCEPT="text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8"
ctxtRoot="http://localhost:8080/hello"

function req() {
  path="$1"
  shift
  echo
  echo "----------------------------------------------------------------------------------"
  ( set -x
    curl --silent --ipv4 --noproxy '*' -H "Accept: $ACCEPT" -D - "$ctxtRoot/$path" $@
  )
}

exec 2>&1

## **********
function isolatedTest() {

  req "problem/items?msg=foo" -X POST
  req "problem/items;id=414ea4a5-d75f-413e-9c77-fc596022cdc5?msg=bar" -X POST
  
  req "problem/items/414ea4a5-d75f-413e-9c77-fc596022cdc5"

  ACCEPT="application/json" req "problem/items"
  ACCEPT="application/json" req "problem/items;pattern=foo"
  req "problem/items/0"
  req "problem/items;pattern=foo/0"

  ACCEPT="application/json" req "problem/locateItemsWORKAROUND"
  ACCEPT="application/json" req "problem/locateItemsWORKAROUND;pattern=foo"
  req "problem/locateItemsWORKAROUND/0"
  req "problem/locateItemsWORKAROUND;pattern=foo/0"

}

## **********
function extraTest() {

  echo
  echo
  echo "##########"
  echo
  echo

  req "form"
  req "form/ping?pong=yeah"
  
  #Create form
  req "form/instances;id=414ea4a5-d75f-413e-9c77-fc596022cdc5;state=ready" -X POST
  
  # List single form by UUID
  ACCEPT="text/plain" req "form/instances/414ea4a5-d75f-413e-9c77-fc596022cdc5"
  req "form/instances/414ea4a5-d75f-413e-9c77-fc596022cdc5/type"
  
  # List form collection
  ACCEPT="application/json" req "form/instances"            
  ACCEPT="application/json" req "form/instances;state=ready" 
  
  # List first form by state
  ACCEPT="text/plain" req "form/instances;state=ready/0" 
  req "form/instances;state=ready/0/state" 
  
  echo
  echo
  echo "##########"
  echo
  echo
  
  #Create form
  req "form/createFormInstanceWORKAROUND;id=414ea4a5-d75f-413e-9c77-fc596022cdc5;state=ready" -X POST
  
  # List single form by UUID
  ACCEPT="text/plain" req "form/locateInstanceWORKAROUND/414ea4a5-d75f-413e-9c77-fc596022cdc5"
  req "form/locateInstanceWORKAROUND/414ea4a5-d75f-413e-9c77-fc596022cdc5/type"
  
  # List form collection
  ACCEPT="application/json" req "form/locateInstancesWORKAROUND"            
  ACCEPT="application/json" req "form/locateInstancesWORKAROUND;state=ready" 
  
  # List first form by state
  ACCEPT="text/plain" req "form/locateInstancesWORKAROUND;state=ready/0" 
  req "form/locateInstancesWORKAROUND;state=ready/0/type" 
  
}

## **********************************************
## **********************************************

isolatedTest
#extraTest
